require 'active_support/core_ext/module/attribute_accessors'
require 'active_support/core_ext/object/try'

require "natural_born_slugger/exceptions"
require "natural_born_slugger/configuration"

module NaturalBornSlugger

  class << self
    attr_accessor :configuration
  end

  def self.configure
    self.configuration ||= Configuration.new

    yield(configuration) if block_given?

    require_internals!

    configuration
  end

  def self.logger
    @logger ||= configuration.logger
  end

  def self.included(base)
    base.extend ClassMethods
  end

private

  def self.require_internals!
    require "natural_born_slugger/class_methods"
  end
end

require "natural_born_slugger/extensions/string"
require "natural_born_slugger/version"
