require "natural_born_slugger/attribute_composer"

module NaturalBornSlugger
  module ClassMethods

    ##
    # Adds a slug to the class. Name is optional.
    #
    def has_slug(name, options={})
      # Use default name if not provided
      name, options = 'slug', name if name.is_a?(Hash)
      NaturalBornSlugger::AttributeComposer.new(name, options).add_to(self)
    end

    ##
    # Adds a natural key to the class. Name is optional.
    #
    def has_natural_key(name, options={})
      # Use default name if not provided
      name, options = 'natural_key', name if name.is_a?(Hash)
      NaturalBornSlugger::AttributeComposer.new(name, options).add_to(self)
    end

    ##
    # Adds a generic composite attribute to the class. Name is required.
    #
    def has_composite_attribute(name, options={})
      NaturalBornSlugger::AttributeComposer.new(name, options).add_to(self)
    end

  end
end
