module NaturalBornSlugger

  class NaturalBornError < StandardError; end

  class IllegalOperationError < NaturalBornError
    def initialize(class_name, method_name, context = nil)
      @class_name = class_name
      @method_name = method_name
      @context = context
      @message = "Cannot call `#{class_name}.#{method_name}"
    end
    def to_s
      [@message, @context].compact.join(': ')+'.'
    end
  end

  class ConfigurationError < NaturalBornError
    def initialize(class_name, attribute, context = nil)
      @class_name = class_name
      @attribute = attribute
      @context = context
      @message = "Composite attribute `#{attribute}` of #{class_name} has not been configured properly"
    end
    def to_s
      [@message, @context].compact.join(': ')+'.'
    end
  end

end
